# -*- coding: utf-8 -*-

#1a) Un "microsatellite" è una porzione di una sequenza di DNA costituita da 
# più ripetizioni consecutive di uno spezzone di 2-5 bp detto "motivo base".
# Si scriva una funzione find_micro che, dato in input una sequenza di DNA 
# (sotto forma di stringa), la stringa che descrive un motivo base, e un numero 
# intero n, trovi tutte le occorrenze dei corrispondenti microsatelliti con 
# numero di ripetizioni maggiore o uguale a n. Ogni occorrenza dovrà essere 
# descritta da una tupla che contiene l'indice d'inizio e il numero di ripetizioni. 
# La funzione find_micro deve restituire una lista con le descrizioni delle 
# occorrenze, in ordine di apparizione lungo la sequenza. Gli indici usati si 
# intendono seguire la convenzione Python.
# 
# Es. 
# s = "ACGACGCGATCGCGCGT"
# #     CG CGCG  CGCGCG
# find_micro(s, "CG", 2) #-> [(4, 2), (10, 3)]
# find_micro(s, "CG", 3) #-> [(10, 3)]
# find_micro(s, "CG", 4) #-> []


import re

def find_micro(motif, seq, minrep=1):
    """
    Returns the list of all microsatellites (tuples containing the start index 
    and length) in "seq" made of at least "minrep" repetitions of "motif"

    """ 
    micros = []

    satelmatches = re.finditer('(%s){%d,}' % (motif, minrep), seq)
    for match in satelmatches:
        micros.append( (match.start(), ((match.end() - match.start()) / len(motif))) )
    return micros
    