# -*- coding: utf-8 -*-

#2a) All'interno di una sequenza di DNA, un motivo base può essere ripetuto 
# per n volte, e di seguito può immediatamente comparire un suo prefisso 
# (massimale). P.es. "AATT" compare in "GAATTAACC" una sola volta, e poi le 
# "AA" seguenti sono un prefisso del motivo base; si può dire allora che il 
# motivo è ripetuto 1.5 volte. Chiamiamo "frazionaria" questo tipo ripetizione.
# Si scriva una funzione first_fracmicro(motif, seq, minrep) che trovi in seq 
# il numero (eventualmente frazionario) di ripetizioni del primo microsatellite
# costituito da almeno "minrep" ripetizioni intere del motivo base "motif".
#
# Es. 
# s="ACGAGCGACCTCAAAA"
# first_fracmicro("CGAC", s, 1) #-> 1.25  


import re

def first_fracmicro(motif, seq, minrep):
    """
    To return the (fractional) number of repetitions in "seq" of "motif" whose 
    value is at least minrep (integer)
    """ 
    motiflen = len(motif)
    mlen = 0
    mymatch = re.search('(%s){%d,}' % (motif, minrep), seq)
    if mymatch is not None:
        end = mymatch.end()
        mlen = end - mymatch.start()
        for c1, c2 in zip(seq[end:end+motiflen], motif):
            if c1 == c2:
                mlen += 1
            else:
                break
    return mlen/float(motiflen)
    