# -*- coding: utf-8 -*-

#3a) Si considerino k diversi motivi base di microsatelliti che abbiano ciascuno 
# una sola occorrenza all'interno del genoma di un individuo. Ciascun motivo 
# base individuerà un solo microsatellite in una ben precisa posizione sul 
# genoma ("locus"). In generale, individui diversi possono presentare un numero 
# di ripetizioni diverse per lo stesso microsatellite; chiamiamo "allele" una 
# specifica variante di un microsatellite con un determinato numero di 
# ripetizioni. 
# In un organismo diploide, ad ogni locus corrispondono due alleli. Chiamiamo
# "firma genetica" di un individuo l'indicazione, per ciascuno dei k loci 
# individuati, dei due alleli presenti sui due cromosomi omologhi - un allele è 
# indicato dal relativo numero di ripetizioni (per semplicità, non frazionario).
#
# Si scriva una funzione half_sign(mlist, seq) che, data una lista "mlist" di 
# k "motif" e una stringa "seq" di DNA, restituisca una lista di tuple ciascuna 
# con il motif e il relativo numero di ripetizioni in "seq". Si supponga 
# che a un motif dato corrisponda un unico microsatellite in "seq".
#  
# Es. 
# s = "AATAATAATCGGGAGGATA"
# half_sign(["AAT","GGA"], s) #-> [('AAT', 3), ('GGA', 2)]


from soluzione1 import find_micro

def half_sign(mlist, seq):
    """
    Considering the sequence "seq", it returns the number of occurrences of the
    base motif in the unique relative microsatellite; this, for all the motifs
    in "mlist".
    """ 
    res = []
    for motif in mlist:
        found = find_micro(motif, seq)
        if found:
            res.append((motif,found[0][1]))
    return res
