# -*- coding: utf-8 -*-

#4a) Un genitore passa al figlio metà del sup patrimonio genetico. Questo 
# significa che, sullo stesso locus, il figlio avrà sempre uno dei due alleli 
# presenti sul genitore (stesso discorso vale per l'altro genitore).
# Si scriva una funzione "potparent(f1, f2)" che, data le firme genetiche di 
# due individui, restituisca "True" se esse sono compatibili con un rapporto 
# genitoriale tra i due, e "False" altrimenti.
# La firma genetica è rappresentata da una lista di tuple, ciascuna indicante 
# la coppia di alleli per un locus, secondo la convenzione descritta nell'es. 3.
#
# Es.
# f1 = [('CAGCGA', 12, 14), ('CCTGGA', 9, 11)]
# f2 = [('CAGCGA', 11, 14), ('CCTGGA', 9, 10)]
# f3 = [('CAGCGA', 11, 14), ('CCTGGA', 8, 10)]
# potparent(f1, f2) # -> True
# potparent(f1, f3) # -> False
# potparent(f2, f3) # -> True


def potparent(f1, f2):
    """
    Predicate to determine if the two full genetic signatures f1 and f2 are 
    compatible with a parental relationship between the relative individuals.    
    """
    d1 = {m:{a1,a2} for m, a1, a2 in f1}
    d2 = {m:{a1,a2} for m, a1, a2 in f2}
    
    mcommon = set(d1.keys()).intersection(set(d2.keys()))
    
    for m in mcommon:
        if not d1[m].intersection(d2[m]):
            return False
    return True
    