# -*- coding: utf-8 -*-

#4b) Si considerino le firme genetiche complete degli individui Alberto, Erica,
# Giovanna e Luigi, le cui sequenze sono contenute nei file "_alberto.fasta", 
# "_erica.fasta", ecc. Siano tali firme relative ai soli seguenti motivi base:
# 'CAGCGA','CCTGGA' e 'GGGGCC'. 
# Sfruttando la funzione sviluppata al punto 4a, si determini quali individui 
# hanno una firma genetica compatibile con quella di un genitore di Erica. 
# Si scrivano i loro nomi in ordine alfabetico su linee successive del file 
# "uso4.txt".
#
# Nota: nel caso in cui non si riescano a estrarre le firme complete per ciasun 
# individuo, si tenga presente che esse sono le seguenti:
# sign_erica    -> [('CAGCGA', 13, 15), ('CCTGGA', 16, 17), ('GGGGCC', 9, 15)]
# sign_alberto  -> [('CAGCGA', 12, 15), ('CCTGGA', 17, 17), ('GGGGCC', 9, 10)]
# sign_giovanna -> [('CAGCGA', 10, 14), ('CCTGGA', 11, 13), ('GGGGCC', 8, 10)]
# sign_luigi    -> [('CAGCGA', 10, 10), ('CCTGGA', 12, 14), ('GGGGCC',13, 15)]


from soluzione4 import potparent
from soluzione3 import half_sign
from uso3 import merge_halves
import Bio.SeqIO as SeqIO

motifs = ['CAGCGA','CCTGGA', 'GGGGCC'] 
names  = ['Erica', 'Alberto', 'Giovanna', 'Luigi']
files  = ['_erica.fasta', '_alberto.fasta', '_giovanna.fasta', '_luigi.fasta']
outfile = "uso4.txt"

#let's get the full signatures for all of them

def get_fullsign(motifs, filename):
    with open(filename,'r') as fin:
        sequit = SeqIO.parse(fin, "fasta")
        n1 = sequit.next()
        n2 = sequit.next()   
    sign1 = half_sign(motifs, str(n1.seq))
    sign2 = half_sign(motifs, str(n2.seq))
    
    return merge_halves(sign1,sign2)

signs = []
for infile in files:
    signs.append(get_fullsign(motifs, infile))

res = []
for name, sign in zip(names[1:], signs[1:]):
    if potparent(signs[0], sign):
        res.append(name)
            
with open(outfile,'w') as fout:
    for name in res:
        fout.write(name+"\n")
